; AHK v2.0 _3D_ small functions ##
; Copyright (c) D.Donchev 

dd_varExist(ByRef v) { ;check if v exist
	return !(&v = &_) 
} ;==========
dd_leading(v, p:= 2, c:= "0") { ;Adding string (c) (p) times at the front of (v)
	Loop p - StrLen(v)
		v:= c v
	return v
} ;==========
dd_toolTip(text:= "", time:= 0) { ;timedFunction - hide text ToolTip after time miliseconds
		ToolTip % text
		SetTimer, LABEL_dd_toolTip,% time? -time:"Off" ;(-) run only once
		return
	LABEL_dd_toolTip: 
		ToolTip
	RETURN
} ;==========
dd_sleep(tm, flag:= "DD_SleepFlag") { ;throw exception that terminate curent action, flag byName
    global
    Sleep(tm)
    if %flag%, throw %flag%
    return !%flag%
} ;==========
dd_msgBox(Text:="", Options:=0, Title:="", Timeout:=0) {
	MsgBox(Options, Title, Text, Timeout)
	return A_MsgBoxResult
} ;==========
dd_setDelim(param, delim:=",", range:=3) { ;set delim delimiters in range into param
	while(strLen(param) > range) {
		r:= delim substr(param,    -range) r
		param:=   substr(param, 1, -range)
	}
	return param r
} ;==========
;function evaluate and format nested expressions in string
;	nested expressions are present in token {expression:format}
;	expression can contain: 
;		1. constants - AHK convention
;		2. variables - "`%variable" ;"`%" needed to be deref variable to value
;   	   need deref() to convert variable to value
;		   example: dd_waitColor(x, y, color, insec
;								,"Nested Expresion: waiting {`%insec-`%A_Index+1} seconds for {`%color:06X} at {`%x}:{`%y}")	
;			        deref() is inside dd_waitColor() that mean deref() "see" all variables seen inside dd_waitColor()
;		3. actions	 - AHK native actions (ONLY)
;	format can be any valid for function format(f, v) formatter 
;	token examples:
;	{expression:02d} - calculate expression and format it with 02d
;	{expression:}	- calculate expression unformatted
;	{expression}		- format omitted (ErrorLevel is set to 1 if ":" missing)
;	{expression:X	- missing ended } - break evaluation and set ErrorLevel to 2
;
;	ErrorLevel
;		1: missing : in token (using {:} like formatter)
;		2: missing } in token (break)
;		3: missing expression in token {}
dd_nestEx(str) { ;NestEx like RegEx
	b:=1
	try {
		while b:= inStr(str, "{",, b) { ;identify next token begin {
			if !(e:= inStr(str, "}",, b)), throw ErrorLevel:= 2 ;missing closing } in token
			if !(m:= inStr(str, ":",, b)) || m > e {        	;missing :<format> in token
				ErrorLevel:= 1, fmt:= ":}", m:= e
			} else fmt:= subStr(str, m  , e-m+1)
			if (exp:= subStr(str, b+1, m-b-1)) != "" { ;eval
				obj:=ComObjCreate("HTMLfile")  ;tidbit code ------------------------------------
				obj.write("<body><script>document.body.innerText=eval('" exp "');</script>") ;--
				exp:= format("{" fmt, obj.body.innerText), obj:= ""	  
			} else ErrorLevel:= 3 ;missing expression
			str:= subStr(str, 1, b-1) . exp . subStr(str, e+1)
	}	} catch {
	}		   
	return str
} ;==========
;pToken:= Gdip_Startup() <<< must be call before using Gdip

;get color at x:y coordinates direct (d==1) or with picture of pixel (d==0)
dd_pixelGetColor(X, Y, dc:= 0, Mask:= 0x00FFFFFF) {
	if dc, RGB:= PixelGetColor(X, Y)
	else { RGB:= Gdip_GetPixel((pBmp:= Gdip_BitmapFromScreen(X "|" Y "|1|1", 0x40CC0020)), 0, 0), Gdip_DisposeImage(pBmp)
	} 
	return RGB & Mask
} ;==========
;Wait for COLOR or not COLOR (parameter: n).
;Hint can void what color at the place of COLOR (variable: pixl).
;Revised wait method (getting color + nested expressions + tooltip cost too much time and now A_Tickcount compensation).
dd_waitColor(x, y, color, insec, fmt:="", n:=0) {
	global
	loop insec {
		t:= A_Tickcount
			comp:= ((pixl:= dd_pixelGetColor(x, y)) == color)
			if(n? !comp: comp), return 1
			if fmt, dd_toolTip(dd_nestEx(deref(fmt)), 2000)
		dd_sleep(998 - A_Tickcount + t) ;1000 too long
	}
	return 0
} ;==========
;made picture at x:y coordinates w width and h height and save it to file
DD_GetImage(x, y, w, h, file) {
	Gdip_SaveBitmapToFile((pBmp:= Gdip_BitmapFromScreen(x "|" y "|" w "|" h, 0x40CC0020)), file)
	Gdip_DisposeImage(pBmp)
} ;==========